"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = exports.createForm = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _cloneDeep = _interopRequireDefault(require("lodash/cloneDeep"));

var _mapValues = _interopRequireDefault(require("lodash/mapValues"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var createForm = function createForm(_ref) {
  var initControls = _ref.controls,
      _ref$initialValues = _ref.initialValues,
      initialValues = _ref$initialValues === void 0 ? {} : _ref$initialValues,
      initFields = _ref.fields,
      other = (0, _objectWithoutProperties2["default"])(_ref, ["controls", "initialValues", "fields"]);
  var controls = (0, _mapValues["default"])(initControls, function (control, name) {
    return _objectSpread(_objectSpread({}, control), {}, {
      title: control.title || name,
      placeholder: control.placeholder || "\u0412\u0432\u0435\u0434\u0438\u0442\u0435 ".concat(control.title || name),
      name: name
    });
  });
  var fields = initFields || Object.keys(controls);
  var values = (0, _cloneDeep["default"])(initialValues);
  return _objectSpread(_objectSpread({}, other), {}, {
    values: values,
    controls: controls,
    fields: fields,
    getValues: function getValues() {
      return values;
    },
    getValue: function getValue(name) {
      return values[name];
    },
    isValidField: function isValidField(name, raw) {
      return (0, _asyncToGenerator2["default"])( /*#__PURE__*/_regenerator["default"].mark(function _callee() {
        var control, value, res;
        return _regenerator["default"].wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                control = controls[name];
                value = control.format ? control.format(raw) : raw;

                if (control.validate) {
                  _context.next = 4;
                  break;
                }

                return _context.abrupt("return", true);

              case 4:
                res = control.validate(value);
                return _context.abrupt("return", res);

              case 6:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }))();
    },
    setFieldValue: function setFieldValue(name, raw) {
      var control = controls[name];
      var value = control.format ? control.format(raw) : raw;
      values[name] = value;
    }
  });
};

exports.createForm = createForm;
var _default = createForm;
exports["default"] = _default;
//# sourceMappingURL=createForm.js.map